import 'package:api_manager/api_manager.dart';
import 'package:dio/dio.dart';

/// Created by Taohid on 02, March, 2020
/// Email: taohid32@gmail.com

class AuthInterceptor extends Interceptor {
  AuthInterceptor(this._authTokenListener);

  AuthTokenListener _authTokenListener;

  @override
  void onRequest(
    RequestOptions options,
    RequestInterceptorHandler handler,
  ) async {
    if (options != null &&
        options?.headers?.containsKey("isauthrequired") == true &&
        options?.headers["isauthrequired"] == true) {
      if (_authTokenListener != null) {
        options.headers.remove("isauthrequired");
        String token = await _authTokenListener();
        options.headers.addAll({
          "Authorization": token,
        });
        handler.next(options);
      } else {
        print(
            '!!!! isAuthRequired is true for this request. But setAuthToken function not define in api manager, Ignoring auth token for request !!!!');
        // return options?.cancelToken?.cancel();
        handler.reject(DioError(requestOptions: options));
      }
    } else {
      handler.next(options);
    }
  }
}
